
/* Global attributes */
#define Math_ATTR_Langue 1
#define Math_ATTR_INLSTYLE 2
#define Math_ATTR_INLSTYLE_VAL_YES 1

/* Local attributes */
#define Math_ATTR_CALLIGRAPHIC 3
#define Math_ATTR_CALLIGRAPHIC_VAL_Activec 1
#define Math_ATTR_NEGATED 4
#define Math_ATTR_NEGATED_VAL_Activen 1
#define Math_ATTR_ACCENT 5
#define Math_ATTR_ACCENT_VAL_Hat 1
#define Math_ATTR_ACCENT_VAL_Acute 2
#define Math_ATTR_ACCENT_VAL_Tilde 3
#define Math_ATTR_ACCENT_VAL_Bar 4
#define Math_ATTR_ACCENT_VAL_Vec 5
#define Math_ATTR_ACCENT_VAL_Dot 6
#define Math_ATTR_ACCENT_VAL_Ddot 7
#define Math_ATTR_ACCENT_VAL_Sprime 8
#define Math_ATTR_ACCENT_VAL_Dprime 9
#define Math_ATTR_ACCENT_VAL_Grave 10
#define Math_ATTR_SHAVE 6
#define Math_ATTR_SHAVE_VAL_Actives 1
#define Math_ATTR_LINE_TYPE 7
#define Math_ATTR_LINE_TYPE_VAL_OverBar 1
#define Math_ATTR_LINE_TYPE_VAL_UnderBar 2
#define Math_ATTR_LINE_TYPE_VAL_OverBrace 3
#define Math_ATTR_LINE_TYPE_VAL_UnderBrace 4
#define Math_ATTR_LINE_TYPE_VAL_WideHat 5
#define Math_ATTR_LINE_TYPE_VAL_WideTilde 6
#define Math_ATTR_INTTYPE 8
#define Math_ATTR_INTTYPE_VAL_Single 1
#define Math_ATTR_INTTYPE_VAL_Double 2
#define Math_ATTR_INTTYPE_VAL_Contour 3
#define Math_ATTR_LIMITOP 9
#define Math_ATTR_LIMITOP_VAL_Inf 1
#define Math_ATTR_LIMITOP_VAL_Limm 2
#define Math_ATTR_LIMITOP_VAL_Liminf 3
#define Math_ATTR_LIMITOP_VAL_Limsup 4
#define Math_ATTR_LIMITOP_VAL_Maxx 5
#define Math_ATTR_LIMITOP_VAL_Minn 6
#define Math_ATTR_LIMITOP_VAL_Sup 7
#define Math_ATTR_ROW_VALIGN 10
#define Math_ATTR_ROW_VALIGN_VAL_Row_top 1
#define Math_ATTR_ROW_VALIGN_VAL_Row_bottom 2
#define Math_ATTR_COLUMN_WIDTH 11
#define Math_ATTR_ROW_ALIGN 12
#define Math_ATTR_ROW_ALIGN_VAL_Row_left 1
#define Math_ATTR_ROW_ALIGN_VAL_Row_center 2
#define Math_ATTR_ROW_ALIGN_VAL_Row_right 3
#define Math_ATTR_REF_COLUMN 13

/* Basic elements */
#define Math_EL_TEXT_UNIT 1
#define Math_EL_GRAPHICS_UNIT 2
#define Math_EL_SYMBOL_UNIT 3
#define Math_EL_PICTURE_UNIT 4
#define Math_EL_PAGE_BREAK 6

/* Constants */
#define Math_EL_EmptyContents 8
#define Math_EL_EmptyHead 9
#define Math_EL_ModuloConstant 10

/* Elements */
#define Math_EL_Math 11
#define Math_EL_Choice_math 12
#define Math_EL_Textual 13
#define Math_EL_Emb_tex 14
#define Math_EL_Fraction 15
#define Math_EL_Subscr_d 16
#define Math_EL_Root_cst 17
#define Math_EL_Int_cst 18
#define Math_EL_Sum_cst 19
#define Math_EL_Stackrel 20
#define Math_EL_Superline 21
#define Math_EL_Lim_like 22
#define Math_EL_Delimiters 23
#define Math_EL_Thin_space 24
#define Math_EL_Medium_space 25
#define Math_EL_Thick_space 26
#define Math_EL_Cdots 27
#define Math_EL_Ldots 28
#define Math_EL_Vdots 29
#define Math_EL_Ddots 30
#define Math_EL_Invoc_Fct 31
#define Math_EL_B_Modulo 32
#define Math_EL_P_Modulo 33
#define Math_EL_Numera_r 34
#define Math_EL_Denomi_r 35
#define Math_EL_Main 36
#define Math_EL_Presub 37
#define Math_EL_Presup 38
#define Math_EL_Subscr 39
#define Math_EL_Supscr 40
#define Math_EL_Root_ord 41
#define Math_EL_Root_obj 42
#define Math_EL_L_part_a 43
#define Math_EL_Integrnd 44
#define Math_EL_Intsym 45
#define Math_EL_Lower_bd 46
#define Math_EL_Upper_bd 47
#define Math_EL_L_part_b 48
#define Math_EL_Operand 49
#define Math_EL_Sumsym 50
#define Math_EL_Lower_ex 51
#define Math_EL_Upper_ex 52
#define Math_EL_Lower_a 53
#define Math_EL_Upper_a 54
#define Math_EL_L_part_c 55
#define Math_EL_R_part_c 56
#define Math_EL_Function_name 57
#define Math_EL_Parameter 58
#define Math_EL_Range 59
#define Math_EL_Left_del 60
#define Math_EL_Included_1 61
#define Math_EL_Right_del 62
#define Math_EL_Array 63
#define Math_EL_Array_head 64
#define Math_EL_Array_body 65
#define Math_EL_Column_head 66
#define Math_EL_Array_row 67
#define Math_EL_Array_cell 68
