/* Types and attributes for the document type Rapport */

/* Global attributes */
#define Rapport_ATTR_Langue 1
#define Rapport_ATTR_Importance 2
#define Rapport_ATTR_Importance_VAL_Definition 1
#define Rapport_ATTR_Importance_VAL_Important 2
#define Rapport_ATTR_Reserve 3

/* Local attributes */
#define Rapport_ATTR_Numero_prem_page 4
#define Rapport_ATTR_Numero_prem_section 5
#define Rapport_ATTR_Type_auteur 6
#define Rapport_ATTR_Type_auteur_VAL_Auteur_principal 1
#define Rapport_ATTR_Type_auteur_VAL_Auteur_secondaire 2

/* Basic elements */
#define Rapport_EL_TEXT_UNIT 1
#define Rapport_EL_GRAPHICS_UNIT 2
#define Rapport_EL_SYMBOL_UNIT 3
#define Rapport_EL_PICTURE_UNIT 4
#define Rapport_EL_PAGE_BREAK 6

/* Elements */
#define Rapport_EL_Rapport 8
#define Rapport_EL_Entete 9
#define Rapport_EL_Titre_courant 10
#define Rapport_EL_Auteurs_courants 11
#define Rapport_EL_Reference 12
#define Rapport_EL_Statut 13
#define Rapport_EL_Date_de_mise_a_jour 14
#define Rapport_EL_Titre 15
#define Rapport_EL_Auteurs 16
#define Rapport_EL_Affiliations 17
#define Rapport_EL_Affiliation 18
#define Rapport_EL_Resume 19
#define Rapport_EL_Mots_cles 20
#define Rapport_EL_Corps 21
#define Rapport_EL_Preambule 22
#define Rapport_EL_Partie_finale 23
#define Rapport_EL_Sections_finales 24
#define Rapport_EL_Bibliographie 25
#define Rapport_EL_Citation_biblio 26
#define Rapport_EL_Annexes 27
#define Rapport_EL_Contenu 28
#define Rapport_EL_Unite 29
#define Rapport_EL_Auteur 30
#define Rapport_EL_Ref_affiliation 31
#define Rapport_EL_Heading 32
#define Rapport_EL_Title 33
#define Rapport_EL_Abstract 34
#define Rapport_EL_Keywords 35
#define Rapport_EL_Annexe 36
#define Rapport_EL_Titre_annexe 37
#define Rapport_EL_Titre_courant_annexe 38
#define Rapport_EL_Suite_sections 39
#define Rapport_EL_Section 40
#define Rapport_EL_Titre_section 41
#define Rapport_EL_Suite_paragraphes 42
#define Rapport_EL_Paragr 43
#define Rapport_EL_Groupe_titre 44
#define Rapport_EL_Titre_groupe 45
#define Rapport_EL_Groupe 46
#define Rapport_EL_Image 47
#define Rapport_EL_Formule_numerotee 48
#define Rapport_EL_Autre_nature 49
#define Rapport_EL_Figure 50
#define Rapport_EL_Illustration 51
#define Rapport_EL_Image_ 52
#define Rapport_EL_Autre_figure 53
#define Rapport_EL_Legende_figure 54

/* Associated elements */
#define Rapport_EL_Note 55
#define Rapport_EL_Notes 69

/* Units */
#define Rapport_EL_Indice 56
#define Rapport_EL_Exposant 57
#define Rapport_EL_Ref_note 58
#define Rapport_EL_Ref_biblio 59
#define Rapport_EL_Ref_figure 60
#define Rapport_EL_Ref_formule 61
#define Rapport_EL_Ref_section 62
#define Rapport_EL_Ref_annexe 63
#define Rapport_EL_Ref_groupe_titre 64
#define Rapport_EL_Autre 65

/* Imported natures */
#define Rapport_EL_Paragraphe 66
#define Rapport_EL_RefBib 67
#define Rapport_EL_Math 68
